#ifndef KERNELDENSITY_H
#define KERNELDENSITY_H

#define DEF_EXT 3

typedef struct
{
	double	*Data;
	int		NoData;
	double	BandWidth;

	double	Min, Max;

	double	Mean, Median, SD;
} KERNELD;

KERNELD*	CreateKD(int NoData, double *Data);
void		FreeKD(KERNELD* KD);

void		SetBandWidth(double BandWidth, KERNELD *KD);
void		SetBandWidthDef(KERNELD *KD);
void		SetBandWidthSilverman(KERNELD *KD);
void		SetBandWidthScott(KERNELD *KD);

double		KDPDF(double X, KERNELD *KD); 
double		KDCDF(double X, KERNELD *KD);

double		FindMode(KERNELD *KD, int Steps);

#endif
		