#if !defined PPPOSTPROCESS
#define PPPOSTPROCESS

/* Save tree slice to compare with bayes Traits. */
//#define	SAVEFILES
#define OUTPUTDIR "ConS"

#include "KernelDensity.h"

typedef struct
{
	char	*Name;
	int		No;

	double	MeanRT;
	double	SDRT;
	
} TAXA;

typedef struct
{
	struct INODE	*Node;
	
	int		NoNode;
	int		NoBL;

	double	MeanNode;
	double	MeanBL;

	double	SDNode;
	double	SDBL;
} SPRAM;

struct INODE
{
	double	TLen;
	double	Len;
	double	Scale;
	double	Height;
	double	*BLList;

	int		ID;
	int		Tip;
	int		Pos;

	int		NoPart;
	int		*Part;
	
	TAXA	*Taxa;

	struct INODE	*Ans;
	struct INODE	**NList;
	int				NoNodes;

	double	Data, Cont, Var, Err;
//	double	Err, Alpha, Sigma;
//	double	EstAlpha, EstSigma, AlphaErr;

	SPRAM	*SPram;

	KERNELD	*KDSigV;
	KERNELD	*KDDeltaB;
	KERNELD	*KDDeltaV;
	KERNELD	*KDR;

	double	ModeSigV;
	double	ModeDeltaB;
	double	ModeDeltaV;
	double	ModeR;
};

typedef struct INODE*	NODE;

typedef struct
{
	double	*BL;
	double	*Mean;
	double	*SD;
	double	*MeanScale;
	int		*NoDiff;
	
	int		No;
} BLINFO;

typedef struct
{
	char	*Name;

	double	StatPos;
	NODE	StartNode;

	double	*Rate;

	double	*Cats;
	int		NoCats;

	int		*NoBL;
	double	*MeanRates;
	double	*SDRates;

	double	TL;
} RATES;

typedef struct
{
	char	*Name;
	double	Point;

	double	*Mean;
	double	*SD;
	int		*NodeNo;

	int		NoTaxa;
} SLICE;

typedef struct
{
	char	*Name;
	int		NoTaxa;

	char	**TNames;
	NODE	Node;
} NODERATIO;

typedef struct
{
	char	*OptFN;
	int		StartIt;
	int		NoCats;

	SLICE	**Slices;
	int		NoSlices;

	RATES	**Rates;
	int		NoRates;

	int		FindRatio;
	double	Ratio;
	int		MinRatioSize;

	int			NoNodeRatio;
	NODERATIO	**NodeRatio;

	int			Normalise;

} OPTIONS;

typedef struct
{
	int		NoTaxa;
	TAXA	**TaxaList;

	NODE	*NodeList;
	int		NoNodes;

	char	*FName;
	FILE	*DFile;

	NODE	Root;
	int		*NodeOrder;

	BLINFO	*BLInfo;

	double	MaxRootToTip;

	OPTIONS	*Opt;

	double	*Sig2;

	int		NoTrees;
	int		TreeNo;

} DATA;

typedef struct
{
	int		NoNodes;
	NODE	*NodeList;
	NODE	Root;

	char	*Name;
	int		SliceNo;

	TAXA	**Taxa;
	int		NoTaxa;

	char	*TreeFN;
} STREE;

TAXA*	CreatTaxa(char *No, char *Name);
void	mdir(char *DirName);
#endif
