#if !defined GENLIB
#define GENLIB

#pragma warning(disable : 4996)


#ifndef TRUE
	#define TRUE 1
#endif

#ifndef FALSE
	#define	FALSE 0
#endif

#define	BUFFERSIZE	655360


#define	MallocErr() MallocErrFull(__FILE__, __LINE__)

static char	*KnownAbvs	= "ACGTRYMKSWHBVDN-\0";
static char BasePatterns[16][4] =
{
/* A */				{ TRUE , FALSE , FALSE , FALSE },
/* C */				{ FALSE , TRUE , FALSE , FALSE },
/* G */				{ FALSE , FALSE , TRUE , FALSE },
/* T */				{ FALSE , FALSE , FALSE , TRUE },

/* R : A | G */		{ TRUE , FALSE , TRUE , FALSE },
/* Y : T | C */		{ FALSE , TRUE , FALSE , TRUE },

/* M : A | C */		{ TRUE , TRUE , FALSE , FALSE },
/* K : G | T */		{ FALSE , FALSE , TRUE , TRUE },

/* S : G | C */		{ FALSE , TRUE , TRUE , FALSE },
/* W : A | T */		{ TRUE , FALSE , FALSE , TRUE },

/* B : C | G | T */	{ FALSE , TRUE , TRUE , TRUE },
/* D : A | G | T */	{ TRUE , FALSE , TRUE , TRUE },
/* H : A | C | T */	{ TRUE , TRUE , FALSE , TRUE },
/* V : A | C | G */	{ TRUE , TRUE , TRUE , FALSE },

/* N : Any */		{ TRUE , TRUE , TRUE , TRUE },
/* - : Any */		{ TRUE , TRUE , TRUE , TRUE }
};

typedef struct
{
	char	*FileName;
	int		NoOfLines;
	int		MaxLine;
	int		Size;
	char	**Data;
} TEXTFILE;

TEXTFILE*	LoadTextFile(char* Name, char DelComments);
void		FreeTextFile(TEXTFILE* TextFile);

typedef struct
{
	int		NoOfSeq;
	char	**Seq;
	char	**Tags;
} FASTA;

typedef struct
{
	double	**Data;
	int		NoOfLines;
	int		*NoPerLine;
} NUMFILE;

typedef struct
{
	int**	Dist;
	int		Size;

	double	MeanDist;
	double	SDDist;
} DISTMATRIX;

FASTA*		LoadFasta(char *FileName);
void		SaveFasta(char *FileName, FASTA* Fasta);
void		WriteFasta(FILE *Str, char* Tag, char *Seq, int CharPerLine);
void		FreeFasta(FASTA *Fasta);
void		AddSequence(FASTA *Fasta, char *Tag, char *Seq);

NUMFILE*	LoadNumFile(char *FileName);
void		FreeNumFile(NUMFILE *NumFile);

DISTMATRIX*	CreateDistMatrix(FASTA*	Fasta, int Strict);
void		FreeDistMatix(DISTMATRIX*	DistMat);
void		PrintDistMatrix(FILE* Str, DISTMATRIX *DM);

FILE*		OpenWrite(char *FileName);
FILE*		OpenRead(char *FileName);
void		MallocErrFull(char* FileName, int LineNo);
char*		StrMake(char* Str);
void		MakeUpper(char* Str);
void		MakeLower(char* Str);
void		RemoveChar(char c, char* String);
int			MakeArgv(char*	string, char *argv[], int argvsize);
int			MakeArgvTab(char*	string, char *argv[], int argvsize);
void		RemoveChar(char c, char* String);
void		ReplaceChar(char Rep, char With, char* String);
void		FillChar(char With, char *Str);

int			IsValidInt(char* Str);
int			IsValidDouble(char* Str);

double*		LoadDouble(char *FileName, int *No);


char*		FormatInt(int No, int Size);
void		RevStr(char * String);
void		MakeComplement(char* DNA);

void 		Swap(void** a, void** b);
void		PrintFixSize(char *String, int Size, FILE* Str);

void		StripBinaryFormText(char *InFileName, char *OutFileName);

void		PrintTime(FILE* Str);



char		GetLastChar(char *Str);
char		GetFistChar(char *Str);
void		DelLastX(char X, char *Str);
int			CountChar(char C, char *Str);

void**		AddToList(int *No, void** OldList, void* Item);
int			NoDigests(int No);

int			IsStartStr(char *Str, char *Sub);
int			IsSubStr(char *Str, char *Sub);
int			BestMatch(char *Str, char *Sub, int* NoDiff);

double		CalcSD(double Sum, double SSE, int No);

#endif
